;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "ps1.vec"
	.INCLUDE "ps1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 Project : Rorganisation de la commande du moteur
;       3 pas  pas du Pousse Seringue (TP3 lve)
;       4 Version : 1
;       5 Rvision: 2 	Date: 06/2005
;       6 Date    : 05/2008
;       7 Author  : Philippe Mariano                
;       8 Company : LYCEE Pierre Emile MARTIN       
;       9 Comments: Rorganisation de la fonction traiter du PS
;      10 
;      11 
;      12 Chip type           : ATMEGA8535
;      13 Clock frequency     : 8,000000 MHz
;      14 Memory model        : Small
;      15 Internal SRAM size  : 512
;      16 External SRAM size  : 0
;      17 Data Stack size     : 128
;      18 *********************************************/
;      19 
;      20 #include <mega8535.h>
;      21 
;      22 // Frquence du Quartz prsent sur la carte SSI
;      23 #define FQUARTZ	8.0E6  
;      24 
;      25 // Bus de commande du moteur
;      26 #define VPH 	PORTB
;      27 
;      28 // Librairies non gnres par Wizard (rajoutes manuellement)      
;      29 #include <ssi.h>      // contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue 
;      30 #include <delay.h>    // contient la fonction delay_ms
;      31 #include <stdio.h>    // contient la fonction sprintf
;      32 
;      33 // Alphanumeric LCD Module functions
;      34 #asm
;      35    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      36 #endasm

;      37 #include <lcd.h>  
;      38 
;      39 
;      40 // -----------------------------------------------------------------------------------------------------
;      41 // Declare your global variables here  
;      42 //-------------------------------------------------------------------------------------------------------
;      43 // type 	nom              				Description
;      44 //-------------------------------------------------------------------------------------------------------
;      45 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
_display_buffer_ligne0:
	.BYTE 0x11
;      46 char display_buffer_ligne1[17]; 			// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      47 unsigned int Vtimer; 					// Rglage de la frquence du moteur pas  pas   
;      48 enum {Arret,Marche,ReglageDebit,ChoixSeringue} 
;      49 			Menu=Arret,Menu_1=Marche; 	// Etats du graphe des transitions "Menu"
;      50 enum {Etat0,Etat1,Etat2,Etat3} ; 	       		//Etats du graphe des transitions "Moteur"
;      51 enum {Terumo50CC,Monoject50CC,BD20CC} seringue=BD20CC;  // Types de seringue
;      52    
;      53 
;      54 // Timer 1 overflow interrupt service routine 
;      55 // Sous programme d'interruption "Moteur"
;      56 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;      57 {

	.CSEG
_timer1_ovf_isr:
	RCALL __SAVEISR
;      58 static unsigned char Etat = Etat0;

	.DSEG

	.CSEG
;      59 TCNT1 = Vtimer; // rechargement du timer 1
	__OUTWR 4,5,44
;      60 switch(Etat) 
	MOV  R30,R9
;      61 	{
;      62        	  case Etat0 : VPH = 9; Etat = Etat1; break;
	CPI  R30,0
	BRNE _0x26
	LDI  R30,LOW(9)
	OUT  0x18,R30
	LDI  R30,LOW(1)
	MOV  R9,R30
	RJMP _0x25
;      63 	  case Etat1 : 		// <- complter 
_0x26:
	CPI  R30,LOW(0x1)
	BREQ _0x28
;      64 	  case Etat2 :          // <- complter
	CPI  R30,LOW(0x2)
	BRNE _0x29
_0x28:
;      65 	  case Etat3 :          // <- complter
	RJMP _0x2A
_0x29:
	CPI  R30,LOW(0x3)
	BRNE _0x25
_0x2A:
;      66 	} 
_0x25:
;      67 }
	RCALL __LOADISR
	RETI
;      68  
;      69 
;      70 //--------------------
;      71 // Programme principal
;      72 //--------------------
;      73 
;      74 void main(void)
;      75 {
_main:
;      76 // Declare your local variables here
;      77 // -----------------------------------------------------------------------------------------------------
;      78 // type 	nom              				Description
;      79 // -----------------------------------------------------------------------------------------------------
;      80 float FPH; 					// frquence calcule  partir de la consigne de dbit
;      81 char Type_Seringue[3][7]={"TERUMO","BD50CC","BD20CC"};
;      82 unsigned char BP;	 			// BP = code ou tat de la touche slectionne
;      83 			    			// seringue = type de seringue slectionne 
;      84 unsigned int dizaines=0, unites=0, diziemes=0; 	// slection du dbit  dizaines unites.diziemes ml/h
;      85 unsigned int dix_C_debit; 			// dix_C_debit = 100*dizaines + 10*unites + diziemes
;      86 
;      87 
;      88 // Input/Output Ports initialization
;      89 // Port A
;      90 PORTA=0x3F;
	SBIW R28,29
	LDI  R24,23
	LDI  R26,LOW(2)
	LDI  R27,HIGH(2)
	LDI  R30,LOW(_0x2D*2)
	LDI  R31,HIGH(_0x2D*2)
	RCALL __INITLOCB
;	FPH -> Y+25
;	Type_Seringue -> Y+4
;	BP -> R16
;	dizaines -> R17,R18
;	unites -> R19,R20
;	diziemes -> Y+2
;	dix_C_debit -> Y+0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      91 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;      92 
;      93 // Port B
;      94 PORTB=0x00;      		       		    	
	RCALL SUBOPT_0x0
;      95 DDRB=0x;                                               // <- complter 
	OUT  0x17,R30
;      96 
;      97 // Timer/Counter 1 initialization
;      98 // Clock source: System Clock
;      99 // Clock value: 7,813 kHz
;     100 // Mode: Normal top=FFFFh
;     101 // OC1A output: Discon.
;     102 // OC1B output: Discon.
;     103 // Noise Canceler: Off
;     104 // Input Capture on Falling Edge
;     105 TCCR1A=0x00;
	CLR  R30
	OUT  0x2F,R30
;     106 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     107 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     108 TCNT1L=0x00;
	OUT  0x2C,R30
;     109 OCR1AH=0x00;
	OUT  0x2B,R30
;     110 OCR1AL=0x00;
	OUT  0x2A,R30
;     111 OCR1BH=0x00;
	OUT  0x29,R30
;     112 OCR1BL=0x00;
	OUT  0x28,R30
;     113 
;     114 // LCD module initialization
;     115 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     116 
;     117 // Global enable interrupts
;     118 #asm("sei")
	sei
;     119 
;     120 // ------------------------------------Message d'accueil-------------------------------------------
;     121 lcd_clear();
	RCALL _lcd_clear
;     122 sprintf(display_buffer_ligne0,"*****TP3 PS*****");
	RCALL SUBOPT_0x1
	__POINTW1FN _44,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     123 sprintf(display_buffer_ligne1,"----------------");
	RCALL SUBOPT_0x3
	__POINTW1FN _44,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     124 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL _Affiche_LCD
;     125 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x4
;     126 //------------------------------------------------------------------------------------------------
;     127 while (1)
_0x2E:
;     128   {
;     129       BP = Lire_BP();
	RCALL SUBOPT_0x5
;     130       
;     131       switch (Menu)
	MOV  R30,R6
;     132       {
;     133        case Arret : if (Menu_1 != Menu)
	CPI  R30,0
	BRNE _0x34
	CP   R6,R7
	BREQ _0x35
;     134                        {
;     135                         PORTB = 0x00;  	// dsactivation du moteur
	RCALL SUBOPT_0x0
;     136                         TIMSK=0x00; 	// inhibition interruption dbordement timer 1
	OUT  0x39,R30
;     137                         sprintf(display_buffer_ligne0,"ETR>CH_S OK>RG_D");
	RCALL SUBOPT_0x1
	__POINTW1FN _44,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     138                     	sprintf(display_buffer_ligne1,"         SET>RUN");
	RCALL SUBOPT_0x3
	__POINTW1FN _44,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     139                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL _Affiche_LCD
;     140                        }
;     141                     	if (BP==OK) Menu = ReglageDebit;
_0x35:
	CPI  R16,55
	BRNE _0x36
	LDI  R30,LOW(2)
	MOV  R6,R30
;     142                       		else if (BP==SET) Menu = Marche;
	RJMP _0x37
_0x36:
	CPI  R16,61
	BRNE _0x38
	RCALL SUBOPT_0x6
;     143                       	       		else if (BP==ENTR) Menu = ChoixSeringue;
	RJMP _0x39
_0x38:
	CPI  R16,62
	BRNE _0x3A
	LDI  R30,LOW(3)
	MOV  R6,R30
;     144                       		               else Menu = Arret;
	RJMP _0x3B
_0x3A:
	CLR  R6
_0x3B:
_0x39:
_0x37:
;     145        		    Menu_1 = Arret; 
	CLR  R7
;     146        break;
	RJMP _0x33
;     147        		   
;     148        case Marche : if (Menu_1 != Menu) 
_0x34:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x3C
	CP   R6,R7
	BRNE PC+2
	RJMP _0x3D
;     149                        { 
;     150                           dix_C_debit = 100*dizaines + 10*unites + diziemes;
	__GETW1R 17,18
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL __MULW12U
	PUSH R31
	PUSH R30
	__GETW1R 19,20
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
;     151                          
;     152                        	  switch (seringue)   // Calcul de FPH=f(C_debit)
	RCALL SUBOPT_0x7
;     153                          	{
;     154                          	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;       
	BRNE _0x41
	LD   R30,Y
	LDD  R31,Y+1
	__GETD2N 0x3E4CCCCD
	RCALL SUBOPT_0x8
	RJMP _0x40
;     155                           	 case Monoject50CC : FPH = (0.2396*dix_C_debit)/10; break;  
_0x41:
	CPI  R30,LOW(0x1)
	BRNE _0x42
	LD   R30,Y
	LDD  R31,Y+1
	__GETD2N 0x3E7559B4
	RCALL SUBOPT_0x8
	RJMP _0x40
;     156                           	 case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;        
_0x42:
	CPI  R30,LOW(0x2)
	BRNE _0x40
	LD   R30,Y
	LDD  R31,Y+1
	__GETD2N 0x3EEEF34D
	RCALL SUBOPT_0x8
;     157                          	} 
_0x40:
;     158                           //calcul de la valeur initiale du timer1
;     159                           Vtimer =  65536 - FQUARTZ/(4096*FPH); 			    
	__GETD1S 25
	__GETD2N 0x45800000
	RCALL __MULF12
	__GETD2N 0x4AF42400
	RCALL __DIVF21
	__GETD2N 0x47800000
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL __CFD1
	__PUTW1R 4,5
;     160                             
;     161                           sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
	RCALL SUBOPT_0x1
	__POINTW1FN _44,68
	RCALL SUBOPT_0x9
	LDI  R24,16
	RCALL SUBOPT_0xA
;     162                           sprintf(display_buffer_ligne1,"      ECHAP>STOP");
	__POINTW1FN _44,87
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     163                           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL _Affiche_LCD
;     164                           TIMSK=0x04; // autorisation interruption dbordement sur timer1
	LDI  R30,LOW(4)
	OUT  0x39,R30
;     165                             
;     166                         }
;     167        		      if (BP==ECHAP) Menu = Arret;
_0x3D:
	CPI  R16,59
	BRNE _0x44
	CLR  R6
;     168                       		else Menu = Marche; 
	RJMP _0x45
_0x44:
	RCALL SUBOPT_0x6
_0x45:
;     169                       		
;     170                       Menu_1 = Marche;
	LDI  R30,LOW(1)
	MOV  R7,R30
;     171        break;
	RJMP _0x33
;     172                       
;     173        case ReglageDebit: if (Menu_1 != Menu)
_0x3C:
	CPI  R30,LOW(0x2)
	BRNE _0x46
	CP   R6,R7
	BREQ _0x47
;     174                           { 
;     175                             Regdebit(&dizaines, &unites, &diziemes);
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Regdebit
;     176                             sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
	RCALL SUBOPT_0x1
	__POINTW1FN _44,104
	RCALL SUBOPT_0x9
	LDI  R24,16
	RCALL SUBOPT_0xA
;     177                             sprintf(display_buffer_ligne1,"ECHP>Arr SET>RUN");
	__POINTW1FN _44,123
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     178                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL _Affiche_LCD
;     179                           }
;     180        		      
;     181                       	  if (BP==ECHAP) Menu = Arret;
_0x47:
	CPI  R16,59
	BRNE _0x48
	CLR  R6
;     182                       		else if (BP == SET) Menu = Marche;
	RJMP _0x49
_0x48:
	CPI  R16,61
	BRNE _0x4A
	LDI  R30,LOW(1)
	RJMP _0x15F
;     183                       		               else Menu = ReglageDebit;
_0x4A:
	LDI  R30,LOW(2)
_0x15F:
	MOV  R6,R30
_0x49:
;     184                       
;     185                           Menu_1 = ReglageDebit;
	LDI  R30,LOW(2)
	MOV  R7,R30
;     186        break;
	RJMP _0x33
;     187        
;     188        case ChoixSeringue: if (Menu_1 != Menu)
_0x46:
	CPI  R30,LOW(0x3)
	BRNE _0x33
	CP   R6,R7
	BREQ _0x4D
;     189                             {
;     190                                	seringue = Menu_Select_Seringue();
	RCALL _Menu_Select_Seringue
	MOV  R8,R30
;     191                          
;     192                          	switch(seringue)
	RCALL SUBOPT_0x7
;     193                          	{
;     194                          	 case Terumo50CC : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
	BRNE _0x51
	RCALL SUBOPT_0x1
	__POINTW1FN _44,140
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0x50
;     195                          	 case Monoject50CC : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
_0x51:
	CPI  R30,LOW(0x1)
	BRNE _0x52
	RCALL SUBOPT_0x1
	__POINTW1FN _44,156
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0x50
;     196                          	 case BD20CC : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
_0x52:
	CPI  R30,LOW(0x2)
	BRNE _0x50
	RCALL SUBOPT_0x1
	__POINTW1FN _44,173
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     197                          	}
_0x50:
;     198                          	sprintf(display_buffer_ligne1,"ECHP>Arr OK>RG_D"); 
	RCALL SUBOPT_0x3
	__POINTW1FN _44,190
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     199                          	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL _Affiche_LCD
;     200                          	
;     201                             } 
;     202                             if (BP==ECHAP) Menu = Arret;
_0x4D:
	CPI  R16,59
	BRNE _0x54
	CLR  R6
;     203                       		else if (BP == OK) Menu = ReglageDebit;
	RJMP _0x55
_0x54:
	CPI  R16,55
	BRNE _0x56
	LDI  R30,LOW(2)
	RJMP _0x160
;     204                       		              else Menu = ChoixSeringue;
_0x56:
	LDI  R30,LOW(3)
_0x160:
	MOV  R6,R30
_0x55:
;     205                             Menu_1 = ChoixSeringue;
	LDI  R30,LOW(3)
	MOV  R7,R30
;     206        break;
;     207       }
_0x33:
;     208    };
	RJMP _0x2E
;     209 }
	ADIW R28,29
_0x58:
	RJMP _0x58
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0xB
	MOV  R30,R10
	CPI  R30,0
	BRNE _0x67
	CPI  R17,63
	BRNE _0x68
	MOV  R16,R17
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xB
	CP   R17,R16
	BRNE _0x69
	LDI  R30,LOW(1)
	MOV  R10,R30
	LDI  R30,LOW(255)
	RJMP _0x15E
_0x69:
	CLR  R30
	RJMP _0x15E
	RJMP _0x6B
_0x68:
	CLR  R30
	RJMP _0x15E
_0x6B:
	RJMP _0x66
_0x67:
	CPI  R30,LOW(0x1)
	BRNE _0x66
	CPI  R17,63
	BREQ _0x6D
	MOV  R16,R17
	RCALL SUBOPT_0xC
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x6E
	CLR  R10
	MOV  R30,R17
	RJMP _0x15E
_0x6E:
	LDI  R30,LOW(255)
	RJMP _0x15E
	RJMP _0x70
_0x6D:
	LDI  R30,LOW(255)
_0x70:
_0x66:
_0x15E:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0xD
	ADIW R28,4
	RET
_Regdebit:
	SBIW R28,43
	LDI  R24,2
	LDI  R26,LOW(40)
	LDI  R27,HIGH(40)
	LDI  R30,LOW(_0x73*2)
	LDI  R31,HIGH(_0x73*2)
	RCALL __INITLOCB
_0x74:
	RCALL _Lire_BP
	STD  Y+42,R30
	LDD  R30,Y+41
	CPI  R30,0
	BREQ PC+2
	RJMP _0x7A
	RCALL SUBOPT_0x10
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x7B
	LDD  R26,Y+47
	LDD  R27,Y+47+1
	RCALL SUBOPT_0x11
	RJMP _0x7C
_0x7B:
	RCALL SUBOPT_0x10
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x7D
	LDD  R26,Y+47
	LDD  R27,Y+47+1
	RCALL SUBOPT_0x12
_0x7D:
_0x7C:
	RCALL SUBOPT_0x10
	LDD  R26,Y+38
	LDD  R27,Y+38+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x7F
	RCALL SUBOPT_0x13
	BREQ _0x7E
_0x7F:
	RCALL SUBOPT_0x14
	__POINTW1FN _114,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x15
	__POINTW1FN _114,17
	RCALL SUBOPT_0x16
	LDI  R24,12
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x10
	STD  Y+38,R30
	STD  Y+38+1,R31
_0x7E:
	RCALL SUBOPT_0x19
	BRNE _0x84
	RCALL SUBOPT_0x10
	ADIW R30,1
	RCALL SUBOPT_0x1A
	RJMP _0x83
_0x84:
	CPI  R30,LOW(0x2F)
	BRNE _0x85
	RCALL SUBOPT_0x10
	SBIW R30,1
	RCALL SUBOPT_0x1A
	RJMP _0x83
_0x85:
	CPI  R30,LOW(0x37)
	BRNE _0x86
	LDI  R30,LOW(1)
	RJMP _0x161
_0x86:
	CPI  R30,LOW(0x3E)
	BRNE _0x88
	LDI  R30,LOW(3)
	RJMP _0x161
_0x88:
	CLR  R30
_0x161:
	STD  Y+41,R30
_0x83:
	CLR  R30
	STD  Y+40,R30
	RJMP _0x79
_0x7A:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x89
	RCALL SUBOPT_0x1B
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x8A
	LDD  R26,Y+45
	LDD  R27,Y+45+1
	RCALL SUBOPT_0x11
	RJMP _0x8B
_0x8A:
	RCALL SUBOPT_0x1B
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x8C
	LDD  R26,Y+45
	LDD  R27,Y+45+1
	RCALL SUBOPT_0x12
_0x8C:
_0x8B:
	RCALL SUBOPT_0x1B
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x8E
	RCALL SUBOPT_0x13
	BREQ _0x8D
_0x8E:
	RCALL SUBOPT_0x14
	__POINTW1FN _114,40
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x15
	__POINTW1FN _114,57
	RCALL SUBOPT_0x16
	LDI  R24,12
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1B
	STD  Y+36,R30
	STD  Y+36+1,R31
_0x8D:
	RCALL SUBOPT_0x19
	BRNE _0x93
	RCALL SUBOPT_0x1B
	ADIW R30,1
	RCALL SUBOPT_0x1C
	RJMP _0x92
_0x93:
	CPI  R30,LOW(0x2F)
	BRNE _0x94
	RCALL SUBOPT_0x1B
	SBIW R30,1
	RCALL SUBOPT_0x1C
	RJMP _0x92
_0x94:
	CPI  R30,LOW(0x37)
	BRNE _0x95
	LDI  R30,LOW(2)
	RJMP _0x162
_0x95:
	CPI  R30,LOW(0x3E)
	BRNE _0x97
	LDI  R30,LOW(3)
	RJMP _0x162
_0x97:
	LDI  R30,LOW(1)
_0x162:
	STD  Y+41,R30
_0x92:
	LDI  R30,LOW(1)
	STD  Y+40,R30
	RJMP _0x79
_0x89:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0x98
	RCALL SUBOPT_0x1D
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x99
	LDD  R26,Y+43
	LDD  R27,Y+43+1
	RCALL SUBOPT_0x11
	RJMP _0x9A
_0x99:
	RCALL SUBOPT_0x1D
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x9B
	LDD  R26,Y+43
	LDD  R27,Y+43+1
	RCALL SUBOPT_0x12
_0x9B:
_0x9A:
	RCALL SUBOPT_0x1D
	LDD  R26,Y+34
	LDD  R27,Y+34+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x9D
	RCALL SUBOPT_0x13
	BREQ _0x9C
_0x9D:
	RCALL SUBOPT_0x14
	__POINTW1FN _114,80
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x15
	__POINTW1FN _114,97
	RCALL SUBOPT_0x16
	LDI  R24,12
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1D
	STD  Y+34,R30
	STD  Y+34+1,R31
_0x9C:
	RCALL SUBOPT_0x19
	BRNE _0xA2
	RCALL SUBOPT_0x1D
	ADIW R30,1
	RCALL SUBOPT_0x1E
	RJMP _0xA1
_0xA2:
	CPI  R30,LOW(0x2F)
	BRNE _0xA3
	RCALL SUBOPT_0x1D
	SBIW R30,1
	RCALL SUBOPT_0x1E
	RJMP _0xA1
_0xA3:
	CPI  R30,LOW(0x37)
	BRNE _0xA4
	CLR  R30
	RJMP _0x163
_0xA4:
	CPI  R30,LOW(0x3E)
	BRNE _0xA6
	LDI  R30,LOW(3)
	RJMP _0x163
_0xA6:
	LDI  R30,LOW(2)
_0x163:
	STD  Y+41,R30
_0xA1:
	LDI  R30,LOW(2)
	STD  Y+40,R30
	RJMP _0x79
_0x98:
	CPI  R30,LOW(0x3)
	BRNE _0x79
	CLR  R30
	CLR  R31
	RJMP _0x15D
_0x79:
	RJMP _0x74
_0x15D:
	ADIW R28,49
	RET
_Menu_Select_Seringue:
	SBIW R28,34
	RCALL __SAVELOCR5
	LDI  R17,2
	LDI  R18,0
	LDI  R19,1
	LDI  R20,0
	RCALL SUBOPT_0x1F
	__POINTW1FN _168,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
_0xA9:
	__CPWRR 17,18,19,20
	BREQ _0xAC
	__GETW1R 17,18
	SBIW R30,0
	BRNE _0xB0
	RCALL SUBOPT_0x20
	__POINTW1FN _168,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0xAF
_0xB0:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xB1
	RCALL SUBOPT_0x20
	__POINTW1FN _168,33
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0xAF
_0xB1:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xAF
	RCALL SUBOPT_0x20
	__POINTW1FN _168,49
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
_0xAF:
	RCALL SUBOPT_0x1F
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	__MOVEWRR 19,20,17,18
_0xAC:
	RCALL SUBOPT_0x5
	MOV  R30,R16
	CPI  R30,LOW(0x1F)
	BRNE _0xB6
	__ADDWRN 17,18,1
	RJMP _0xB5
_0xB6:
	CPI  R30,LOW(0x2F)
	BRNE _0xB7
	__SUBWRN 17,18,1
	RJMP _0xB5
_0xB7:
	CPI  R30,LOW(0x37)
	BRNE _0xB5
	__GETW1R 17,18
	RJMP _0x15C
_0xB5:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	CP   R30,R17
	CPC  R31,R18
	BRLT _0xB9
	__GETWRN 17,18,2
	RJMP _0xBA
_0xB9:
	__CPWRN 17,18,3
	BRLT _0xBB
	__GETWRN 17,18,0
_0xBB:
_0xBA:
	RJMP _0xA9
_0x15C:
	RCALL __LOADLOCR5
	ADIW R28,39
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x21
	SBIW R30,0
	BREQ _0xF2
	RCALL SUBOPT_0x21
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xF3
_0xF2:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0xF3:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xF5:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xF7
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xFB
	CPI  R19,37
	BRNE _0xFC
	LDI  R16,LOW(1)
	RJMP _0xFD
_0xFC:
	RCALL SUBOPT_0x22
_0xFD:
	RJMP _0xFA
_0xFB:
	CPI  R30,LOW(0x1)
	BRNE _0xFE
	CPI  R19,37
	BRNE _0xFF
	RCALL SUBOPT_0x22
	LDI  R16,LOW(0)
	RJMP _0xFA
_0xFF:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x100
	LDI  R17,LOW(1)
	RJMP _0xFA
_0x100:
	CPI  R19,43
	BRNE _0x101
	LDI  R21,LOW(43)
	RJMP _0xFA
_0x101:
	CPI  R19,32
	BRNE _0x102
	LDI  R21,LOW(32)
	RJMP _0xFA
_0x102:
	RJMP _0x103
_0xFE:
	CPI  R30,LOW(0x2)
	BRNE _0x104
_0x103:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x105
	ORI  R17,LOW(128)
	RJMP _0xFA
_0x105:
	RJMP _0x106
_0x104:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xFA
_0x106:
	CPI  R19,48
	BRLO _0x109
	CPI  R19,58
	BRLO _0x10A
_0x109:
	RJMP _0x108
_0x10A:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xFA
_0x108:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x10E
	RCALL SUBOPT_0x23
	LD   R30,X
	RCALL SUBOPT_0x24
	RJMP _0x10F
_0x10E:
	CPI  R30,LOW(0x73)
	BRNE _0x111
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x25
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x112
_0x111:
	CPI  R30,LOW(0x70)
	BRNE _0x114
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x25
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x112:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x115
_0x114:
	CPI  R30,LOW(0x64)
	BREQ _0x118
	CPI  R30,LOW(0x69)
	BRNE _0x119
_0x118:
	ORI  R17,LOW(4)
	RJMP _0x11A
_0x119:
	CPI  R30,LOW(0x75)
	BRNE _0x11B
_0x11A:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x11C
_0x11B:
	CPI  R30,LOW(0x58)
	BRNE _0x11E
	ORI  R17,LOW(8)
	RJMP _0x11F
_0x11E:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x14D
_0x11F:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x11C:
	SBRS R17,2
	RJMP _0x121
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x26
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x122
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x122:
	CPI  R21,0
	BREQ _0x123
	SUBI R16,-LOW(1)
	RJMP _0x124
_0x123:
	ANDI R17,LOW(251)
_0x124:
	RJMP _0x125
_0x121:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x26
_0x125:
_0x115:
	SBRC R17,0
	RJMP _0x126
_0x127:
	CP   R16,R20
	BRSH _0x129
	SBRS R17,7
	RJMP _0x12A
	SBRS R17,2
	RJMP _0x12B
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x12C
_0x12B:
	LDI  R19,LOW(48)
_0x12C:
	RJMP _0x12D
_0x12A:
	LDI  R19,LOW(32)
_0x12D:
	RCALL SUBOPT_0x22
	SUBI R20,LOW(1)
	RJMP _0x127
_0x129:
_0x126:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x12E
_0x12F:
	CPI  R18,0
	BREQ _0x131
	SBRS R17,3
	RJMP _0x132
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x164
_0x132:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x164:
	ST   -Y,R30
	RCALL SUBOPT_0x27
	CPI  R20,0
	BREQ _0x134
	SUBI R20,LOW(1)
_0x134:
	SUBI R18,LOW(1)
	RJMP _0x12F
_0x131:
	RJMP _0x135
_0x12E:
_0x137:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x139
	SBRS R17,3
	RJMP _0x13A
	SUBI R19,-LOW(7)
	RJMP _0x13B
_0x13A:
	SUBI R19,-LOW(39)
_0x13B:
_0x139:
	SBRC R17,4
	RJMP _0x13D
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x13F
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x13E
_0x13F:
	ORI  R17,LOW(16)
	RJMP _0x141
_0x13E:
	CP   R20,R18
	BRLO _0x143
	SBRS R17,0
	RJMP _0x144
_0x143:
	RJMP _0x142
_0x144:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x145
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x141:
	SBRS R17,2
	RJMP _0x146
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x27
	CPI  R20,0
	BREQ _0x147
	SUBI R20,LOW(1)
_0x147:
_0x146:
_0x145:
_0x13D:
	RCALL SUBOPT_0x22
	CPI  R20,0
	BREQ _0x148
	SUBI R20,LOW(1)
_0x148:
_0x142:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x138
	RJMP _0x137
_0x138:
_0x135:
	SBRS R17,0
	RJMP _0x149
_0x14A:
	CPI  R20,0
	BREQ _0x14C
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x24
	RJMP _0x14A
_0x14C:
_0x149:
_0x14D:
_0x10F:
	LDI  R16,LOW(0)
_0xFA:
	RJMP _0xF5
_0xF7:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x28
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x28
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x29
	LDD  R11,Y+1
	LDD  R12,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x29
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x29
	RCALL __lcd_ready
	RCALL SUBOPT_0xF
	RCALL __lcd_write_data
	CLR  R30
	MOV  R12,R30
	MOV  R11,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R11
	CP   R13,R11
	BRSH _0x155
	__lcd_putchar1:
	INC  R12
	RCALL SUBOPT_0xE
	ST   -Y,R12
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x155:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R13,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x2A
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x29
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x29
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x29
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0x15A
	CLR  R30
	RJMP _0x15B
_0x15A:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x29
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x15B:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES
SUBOPT_0x2:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	RCALL _Lire_BP
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(1)
	MOV  R6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R30,R8
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41200000
	RCALL __DIVF21
	__PUTD1S 25
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R8
	CLR  R31
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	RCALL __MULW12U
	MOVW R26,R28
	ADIW R26,8
	ADD  R30,R26
	ADC  R31,R27
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	__GETW1R 17,18
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	__GETW1R 19,20
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	RCALL _sprintf
	ADIW R28,20
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x10:
	LDD  R26,Y+47
	LDD  R27,Y+47+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RCALL __PUTWP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x12:
	CLR  R30
	CLR  R31
	RCALL __PUTWP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	LDD  R30,Y+41
	LDD  R26,Y+40
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x14:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x16:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+51
	LDD  R27,Y+51+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+53
	LDD  R27,Y+53+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDD  R26,Y+55
	LDD  R27,Y+55+1
	RCALL __GETW1P
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x17:
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	LDD  R30,Y+42
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDD  R26,Y+47
	LDD  R27,Y+47+1
	RCALL __PUTWP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1B:
	LDD  R26,Y+45
	LDD  R27,Y+45+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDD  R26,Y+45
	LDD  R27,Y+45+1
	RCALL __PUTWP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1D:
	LDD  R26,Y+43
	LDD  R27,Y+43+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDD  R26,Y+43
	LDD  R27,Y+43+1
	RCALL __PUTWP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x20:
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x22:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x23:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x29:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2A:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

