/*********************************************
Project : Rorganisation de la commande du moteur
pas  pas du Pousse Seringue (TP3 lve)
Version : 1
Rvision: 2 	Date: 06/2005
Date    : 05/2008
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Rorganisation de la fonction traiter du PS


Chip type           : ATMEGA8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>

// Frquence du Quartz prsent sur la carte SSI
#define FQUARTZ	8.0E6  

// Bus de commande du moteur
#define VPH 	PORTB

// Librairies non gnres par Wizard (rajoutes manuellement)      
#include <ssi.h>      // contient les fonctions Lire_BP, Affiche_LCD, Regdebit, Select_Seringue 
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>  


// -----------------------------------------------------------------------------------------------------
// Declare your global variables here  
//-------------------------------------------------------------------------------------------------------
// type 	nom              				Description
//-------------------------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 			// tampon ligne 1 de l'afficheur
unsigned int Vtimer; 					// Rglage de la frquence du moteur pas  pas   
enum {Arret,Marche,ReglageDebit,ChoixSeringue} 
			Menu=Arret,Menu_1=Marche; 	// Etats du graphe des transitions "Menu"
enum {Etat0,Etat1,Etat2,Etat3} ; 	       		//Etats du graphe des transitions "Moteur"
enum {Terumo50CC,Monoject50CC,BD20CC} seringue=BD20CC;  // Types de seringue
   

// Timer 1 overflow interrupt service routine 
// Sous programme d'interruption "Moteur"
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
static unsigned char Etat = Etat0;
TCNT1 = Vtimer; // rechargement du timer 1
switch(Etat) 
	{
       	  case Etat0 : VPH = 9; Etat = Etat1; break;
	  case Etat1 : 		// <- complter 
	  case Etat2 :          // <- complter
	  case Etat3 :          // <- complter
	} 
}
 

//--------------------
// Programme principal
//--------------------

void main(void)
{
// Declare your local variables here
// -----------------------------------------------------------------------------------------------------
// type 	nom              				Description
// -----------------------------------------------------------------------------------------------------
float FPH; 					// frquence calcule  partir de la consigne de dbit
char Type_Seringue[3][7]={"TERUMO","BD50CC","BD20CC"};
unsigned char BP;	 			// BP = code ou tat de la touche slectionne
			    			// seringue = type de seringue slectionne 
unsigned int dizaines=0, unites=0, diziemes=0; 	// slection du dbit  dizaines unites.diziemes ml/h
unsigned int dix_C_debit; 			// dix_C_debit = 100*dizaines + 10*unites + diziemes


// Input/Output Ports initialization
// Port A
PORTA=0x3F;
DDRA=0x00;

// Port B
PORTB=0x00;      		       		    	
DDRB=0x;                                               // <- complter 

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")

// ------------------------------------Message d'accueil-------------------------------------------
lcd_clear();
sprintf(display_buffer_ligne0,"*****TP3 PS*****");
sprintf(display_buffer_ligne1,"----------------");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
delay_ms(3000);
//------------------------------------------------------------------------------------------------
while (1)
  {
      BP = Lire_BP();
      
      switch (Menu)
      {
       case Arret : if (Menu_1 != Menu)
                       {
                        PORTB = 0x00;  	// dsactivation du moteur
                        TIMSK=0x00; 	// inhibition interruption dbordement timer 1
                        sprintf(display_buffer_ligne0,"ETR>CH_S OK>RG_D");
                    	sprintf(display_buffer_ligne1,"         SET>RUN");
                    	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                       }
                    	if (BP==OK) Menu = ReglageDebit;
                      		else if (BP==SET) Menu = Marche;
                      	       		else if (BP==ENTR) Menu = ChoixSeringue;
                      		               else Menu = Arret;
       		    Menu_1 = Arret; 
       break;
       		   
       case Marche : if (Menu_1 != Menu) 
                       { 
                          dix_C_debit = 100*dizaines + 10*unites + diziemes;
                         
                       	  switch (seringue)   // Calcul de FPH=f(C_debit)
                         	{
                         	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;       
                          	 case Monoject50CC : FPH = (0.2396*dix_C_debit)/10; break;  
                          	 case BD20CC : FPH = (0.4667*dix_C_debit)/10; break;        
                         	} 
                          //calcul de la valeur initiale du timer1
                          Vtimer =  65536 - FQUARTZ/(4096*FPH); 			    
                            
                          sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
                          sprintf(display_buffer_ligne1,"      ECHAP>STOP");
                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                          TIMSK=0x04; // autorisation interruption dbordement sur timer1
                            
                        }
       		      if (BP==ECHAP) Menu = Arret;
                      		else Menu = Marche; 
                      		
                      Menu_1 = Marche;
       break;
                      
       case ReglageDebit: if (Menu_1 != Menu)
                          { 
                            Regdebit(&dizaines, &unites, &diziemes);
                            sprintf(display_buffer_ligne0,"%s= %-u%-u.%-uml/h",Type_Seringue[seringue],dizaines,unites,diziemes);
                            sprintf(display_buffer_ligne1,"ECHP>Arr SET>RUN");
                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                          }
       		      
                      	  if (BP==ECHAP) Menu = Arret;
                      		else if (BP == SET) Menu = Marche;
                      		               else Menu = ReglageDebit;
                      
                          Menu_1 = ReglageDebit;
       break;
       
       case ChoixSeringue: if (Menu_1 != Menu)
                            {
                               	seringue = Menu_Select_Seringue();
                         
                         	switch(seringue)
                         	{
                         	 case Terumo50CC : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
                         	 case Monoject50CC : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
                         	 case BD20CC : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
                         	}
                         	sprintf(display_buffer_ligne1,"ECHP>Arr OK>RG_D"); 
                         	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                         	
                            } 
                            if (BP==ECHAP) Menu = Arret;
                      		else if (BP == OK) Menu = ReglageDebit;
                      		              else Menu = ChoixSeringue;
                            Menu_1 = ChoixSeringue;
       break;
      }
   };
}
